      subroutine adiawf(rs,lsmax,nR,dR,Jmax,fK,eta,chi)
      implicit real*8(a-h,o-z)
      include 'parameter.f'
      complex*16 chi(0:nRmax,0:Jmax),pUopt,pUopt1
      parameter (maxch=4, maxls=2, mxlmbd=2*maxls, eps=1.D-1)
      integer*4  ls(maxch),LL(maxch)
      complex*16 A(maxch,maxch,0:nRmax),U(0:mxlmbd,0:nRmax)
      complex*16 w(maxch,maxch,0:nRmax),Rm(maxch,maxch),Aw
      complex*16 Z(maxch,maxch,0:nRmax),Dm(maxch,maxch),det
      real*8     F1(0:Lmax0),F2(0:Lmax0),G1(0:Lmax0),G2(0:Lmax0)
      complex*16 H1(0:Lmax0),H2(0:Lmax0),Smat
      parameter (ngld=51)
      real*8    xgld(ngld),wgld(ngld),P(0:mxlmbd,ngld)
      save      xgld,wgld,P
      character cmt(maxch)
      logical   first,smatou,potout
      data      first/.true./,smatou,potout/2*.false./,cmt/' ',3*'#'/
      if (first) then   ! prepare pivot, weight & legendre-func.
         call gauleg(-1.D0,1.D0,xgld,wgld,ngld)
         do n=1,ngld
            P(0,n)=1.D0
            P(1,n)=xgld(n)
            do m=2,lsmax*2
               P(m,n)=((2*m-1)*xgld(n)*P(m-1,n)-(m-1)*P(m-2,n))/m
            enddo
         enddo
         first=.false.
      endif
      if (smatou.or.potout) write(6,'(A,F8.4)') '#  rs=',rs
c     multipole-expand Opt. Pot. (pUopt includes 2*mu/h^2)
      do iR=0,nR
         RL=iR*dR
         do lmbd=0,lsmax*2,2
            U(lmbd,iR)=0.D0
            do n=1,ngld
               r1=sqrt(RL**2+(rs/2.D0)**2+RL*rs*xgld(n))
               r2=sqrt(RL**2+(rs/2.D0)**2-RL*rs*xgld(n))
               U(lmbd,iR)=U(lmbd,iR)+P(lmbd,n)*wgld(n)*
     &                  (pUopt(r1,RL,lmbd)+pUopt(r2,RL,lmbd))
            enddo
            U(lmbd,iR)=U(lmbd,iR)*sqrt(2.D0*lmbd+1.D0)/2.D0
         enddo
         if (potout) write(6,'(F5.1,1p6E11.3)') iR*dR,
     &        (U(lmbd,iR)/sqrt(2*lmbd+1.D0)/dble(pUopt1()),lmbd=0,4,2)
      enddo
      iR1=nR-2
      iR2=nR
      call coulfg(fK*dR*iR1,eta,0,Jmax+lsmax,F1,G1)
      call coulfg(fK*dR*iR2,eta,0,Jmax+lsmax,F2,G2)
      do L=0,Jmax+lsmax
         H1(L)=dcmplx(G1(L),F1(L))
         H2(L)=dcmplx(G2(L),F2(L))
      enddo
      dR2=dR*dR
      do JS=0,Jmax
c        prepare "channel"s
         nch=0
         do ils=0,lsmax,2
            do iLL=abs(JS-ils),JS+ils,2
               nch=nch+1
               ls(nch)=ils
               LL(nch)=iLL
            enddo
         enddo
c        prepare A_ij, Z_ij(0-h), w_ij(0-h)
         do i=1,nch
            do j=1,nch
               do iR=1,nR
                  RL=iR*dR
                  A(i,j,iR)=delta(i,j)*(LL(i)*(LL(i)+1)/(RL*RL)-fK*fK)
                  do lmbd=abs(ls(i)-ls(j)),ls(i)+ls(j),2
                     A(i,j,iR)=A(i,j,iR)+
     &                    (-1)**(ls(i)+LL(j)+JS)
     &                    *sqrt((2*lmbd+1)*(2*ls(i)+1)*(2*LL(i)+1.D0))
     &                    *clebz(2*ls(i),2*lmbd,2*ls(j))
     &                    *clebz(2*LL(i),2*lmbd,2*LL(j))
     &                    *rac  (2*ls(i),2*LL(i),2*ls(j),2*LL(j),
     &                           2*JS,2*lmbd)
     &                    *U(lmbd,iR)
                  enddo
               enddo
               Z(i,j,0)=0.D0
               w(i,j,0)=0.D0
               Z(i,j,1)=eps* delta(i,j)
               w(i,j,1)=eps*(delta(i,j)+dR2/12.D0*A(i,j,1))
            enddo
         enddo
c        solve Z_ij & w_ij
         do iR=1,nR-1
            do i=1,nch
               do j=1,nch
                  Aw=(0.D0,0.D0)
                  do k=1,nch
                     Aw=Aw+A(i,k,iR)*w(k,j,iR)
                  enddo
                  Z(i,j,iR+1)=2.D0*Z(i,j,iR)+dR2*Aw-Z(i,j,iR-1)
               enddo
            enddo
            jR=iR+1
            do i=1,nch
               do j=1,nch
                  w(i,j,jR)=0.D0
                  do k=1,nch
                     w(i,j,jR)=w(i,j,jR)+
     &                    (delta(i,k)+dR2/12.D0*A(i,k,jR))*Z(k,j,jR)
                  enddo
               enddo
            enddo
         enddo
c        normalize w_ij
         do i=1,nch
            do j=1,nch
               Dm(i,j)=w(j,i,iR2)*H1(LL(j))-w(j,i,iR1)*H2(LL(j))
            enddo
         enddo
         call matinv(Dm,maxch,nch,det)
         do i=1,nch
            do j=1,nch
               Rm(i,j)=(F2(LL(i))*H1(LL(i))-F1(LL(i))*H2(LL(i)))*Dm(i,j)
            enddo
         enddo
c        output S-matrix for each channel
         if (smatou) then
            if (JS.eq.0) write(6,'(A,2A9,A7)')
     &           '#  J l  L','S(real)','S(imag)','|S|^2'
            do j=1,nch
               chi(iR2,JS)=0.D0
               do k=1,nch
                  chi(iR2,JS)=chi(iR2,JS)+Rm(1,k)*w(j,k,iR2)
               enddo
               Smat=delta(1,j)+(0.D0,2.D0)*
     &              (chi(iR2,JS)-delta(1,j)*F2(LL(1)))/H2(LL(j))
               write(6,'(A,I3,I2,I3,2F9.5,F8.5)')
     &              cmt(j),JS,ls(j),LL(j),Smat,abs(Smat)**2
            enddo
         endif
c        calculate full wave-func. only for elastic channel
         do iR=0,nR
            chi(iR,JS)=0.D0
            do k=1,nch
               chi(iR,JS)=chi(iR,JS)+Rm(1,k)*w(1,k,iR)	! j=1 (elastic chan.)
            enddo
         enddo
      enddo
      return
      entry adiaou(ismato,ipotou)
      smatou=(ismato.ne.0)
      potout=(ipotou.ne.0)
      return
      end

      real*8 function delta(i,j)
      if (i.eq.j) then
         delta=1.D0
      else
         delta=0.D0
      endif
      return
      end

      complex*16 function pUopt(R,RL,ich)
      implicit real*8(a-h,o-z)
      real*8     mu,mp
      parameter (mu=931.494*(1.007275+1.008665)/2.)
      parameter (hc=197.32705, e2=hc/137.036)
      save       VR,rR,aR,WV,WD,rI,aI,rC,ZZ,fac
      complex*16 pUopt0,pUopt1
c     Coulomb interaction does NOT contribute to coupled-channels !!!
      pUopt=0.D0
      if (ich.eq.0) then
         if (RL.gt.rC) then
            pUopt=ZZ*e2/RL
         else
            pUopt=ZZ*e2*(3.D0-(RL/rC)**2)/2.D0/rC
         endif
      endif
      w=(R-rR)/aR
      if (w.lt.7.D1) pUopt=pUopt-VR/(1.D0+exp(w))
      w=(R-rI)/aI
      if (w.lt.7.D1) pUopt=pUopt-dcmplx(0.D0,
     &     WV/(1.D0+exp(w))+4.D0*WD*exp(w)/(1.D0+exp(w))**2)
      pUopt=pUopt*fac
      return
c     read-in potential parameters
      entry pUopt0(A,Z,mp,Z1,iprnt)
      read(5,*) VR,rR,aR,WV,WD,rI,aI,rC
      if (iprnt.ne.0) then
         write(6,'(/A/)') ' optical potential parameters for "adiawf"'
         write(6,'(2X,A,F7.3,13X,4(2X,A,F7.3))')
     &        'VR =',VR,'rR =',rR,'aR =',aR,'rC =',rC
         write(6,'(4(2X,A,F7.3))')
     &        'WV =',WV,'WD =',WD,'rI =',rI,'aI =',aI
      endif
      amu=mp*A/(mp+A)       ! reduced mass for total system !!
      fac=2.D0*mu*amu/hc**2
c     fac=amu*0.048196758d0 ! to be compatible with TWOFNR
      ZZ=Z1*Z               ! charge product for cluster !!
      rR=rR*A**(1.D0/3.D0)
      rI=rI*A**(1.D0/3.D0)
      rC=rC*A**(1.D0/3.D0)
      pUopt0=fac
      return
c     return a factor (2*mu*c^2/hc^2)
      entry pUopt1()
      pUopt1=fac
      return
      end
