      subroutine coulfg(rho,eta,minl,maxl,fc,gc)
      implicit real*8(a-h,o-z)
      include 'parameter.f'
c     coulomb function routine of manchester ( barnett et. al. ).
      dimension fc(*),fcp(Lmax0+1),gc(*),gcp(Lmax0+1)
      real*8 k,k1,k2,k3,k4,m1,m2,m3,m4
      accu=1.d-15
      step=1.d3
      pace=step
      acc=accu
      if(pace.lt.100.d0) pace=100.d0
      if(acc.lt.1.0d-15.or.acc.gt.1.0d-6) acc=1.0d-6
      r=rho
      ktr=1
      lmax=maxl
      lmin1= minl+1
      xll1=dble(float(minl*lmin1))
      eta2=eta*eta
      turn=eta+dsqrt(eta2+xll1)
      if(r.lt.turn.and.dabs(eta).ge.1.0d-6) ktr=-1
      ktrp=ktr
      go to 2
    1 r=turn
      tf=f
      tfp=fp
      lmax=minl
      ktrp=1
    2 etar=eta*r
      rho2=  r*r
      pl=dble(float(lmax+1))
      pmx=pl+0.5d0
c     continued fraction for fp(maxl)/f(maxl)  xl is f  xlprime is fp **
      fp=eta/pl+pl/r
      dk=etar*2.d0
      del=0.d0
      d=0.d0
      f=1.d0
      k=(pl*pl-pl+etar)*(2.d0*pl-1.d0)
      if(pl*pl+pl+etar.ne.0.d0) go to 3
      r=r+1.0d-6
      go to 2
    3 h=(pl*pl+eta2)*(1.d0-pl*pl)*rho2
      k=k+dk+pl*pl*6.d0
      d=1.d0/(d*h+k)
      del=del*(d*k-1.d0)
      if(pl.lt.pmx) del=-r*(pl*pl+eta2)*(pl+1.d0)*d/pl
      pl=pl+1.d0
      fp=fp+del
      if(d.lt.0.d0) f=-f
      if(pl.gt.2.d4) go to 11
      if(dabs(del/fp).ge.acc) go to 3
      fp=f*fp
      if( lmax.eq.minl) go to 5
      fc (lmax+1)=f
      fcp(lmax+1)=fp
c     downward recursion to minl for f and fp, arrays gc,gcp are storage
      l=lmax
      do 4 lp=lmin1,lmax
      pl=dble(float(l))
      gc (l+1)=eta/pl+pl/r
      gcp(l+1)=dsqrt(eta2+pl*pl)/pl
      fc (l)=(gc(l+1)*fc(l+1)+fcp(l+1))/gcp(l+1)
      fcp(l)=gc(l+1)*fc(l)-gcp(l+1)*fc(l+1)
    4 l=l-1
      f=fc (lmin1)
      fp=fcp(lmin1)
    5 if(ktrp.eq.-1) go to 1
c     repeat for r=turn if rho lt turn
c     now obtain p+i.q for minl from continued fraction (32)
c     real arithmetic to facilitate conversion to ibm using real*8
      p=0.d0
      q=r-eta
      pl=0.d0
      ar=-(eta2+xll1)
      ai= eta
      br=2.d0*q
      bi=2.d0
      wi=2.d0*eta
      dr= br/(br*br+bi*bi)
      di=-bi/(br*br+bi*bi)
      dp=-(ar*di+ai*dr)
      dq=(ar*dr-ai*di)
    6 p=p+dp
      q=q+dq
      pl=pl+2.d0
      ar=ar+pl
      ai=ai+wi
      bi=bi+2.d0
      d=ar*dr-ai*di+br
      di=ai*dr+ar*di+bi
      t=1.d0/(d*d+di*di)
      dr=t*d
      di=-t*di
      h=br*dr-bi*di-1.d0
      k=bi*dr+br*di
      t=dp*h-dq*k
      dq=dp*k +dq*h
      dp=t
      if(pl.gt.4.6d4) go to 11
      if(dabs(dp)+dabs(dq).ge.(dabs(p)+dabs(q))*acc) go to 6
      p=p/r
      q=q/r
c     solve for fp,g,gp and normalise f  at l=minl
      g=(fp-p*f)/q
      gp=p*g-q*f
      w=1.d0/dsqrt(fp*g-f*gp)
      g=w*g
      gp=w*gp
      if(ktr.eq.1) go to 8
      f=tf
      fp=tfp
      lmax=maxl
c     runge-kutta integration of g(minl) and gp(minl) inwards from turn
c     see fox and mayers 1968 pg 202
      if(rho.lt.0.2d0*turn) pace=999.d0
      r3=1.d0/3.d0
      h=(rho-turn)/(pace+1.d0)
      h2=0.5d0*h
      i2=idint(pace+0.001d0)
      etah=eta*h
      h2ll=h2*xll1
      s=(etah+h2ll/r  )/r-h2
    7 rh2=r+h2
      t=(etah+h2ll/rh2)/rh2-h2
      k1=h2*gp
      m1=s*g
      k2=h2*(gp+m1)
      m2=t*(g +k1)
      k3=h*(gp+m2)
      m3=t*(g +k2)
      m3=   m3+m3
      k4=h2*(gp+m3)
      rh=r+h
      s=(etah+h2ll/rh )/rh-h2
      m4=s*(g+k3)
      g=g +(k1+k2+k2+k3+k4)*r3
      gp=gp+(m1+m2+m2+m3+m4)*r3
      r=rh
      i2=i2-1
      if(dabs(gp).gt.1.0d75)go to 11
      if(i2.ge.0) go to 7
      w=1.d0/(fp*g-f*gp)
c     upward recursion from gc(minl) and gcp(minl),stored values are r,s
c     renormalise fc,fcp for each l-value
    8 gc(lmin1)=g
      gcp(lmin1)=gp
      if(lmax.eq.minl) go to 10
      do  9  l=lmin1,lmax
      t=gc(l+1)
      gc(l+1)=(gc(l)*gc(l+1)-gcp(l))/gcp(l+1)
      gcp(l+1)= gc(l)*gcp(l+1)-gc(l+1)*t
      fc(l+1)=w*fc(l+1)
    9 fcp(l+1)=w*fcp(l+1)
      fc(lmin1)=fc(lmin1)*w
      fcp(lmin1)=fcp(lmin1)*w
      return
   10 fc (lmin1)=w*f
      fcp(lmin1)=w*fp
      return
   11 w=0.d0
      g=0.d0
      gp=0.d0
      go to 8
      end
